"{ Package: 'cvut:fel/cface' }"

"{ NameSpace: Cface }"

CDefinitionNode subclass:#CTypeNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Cface-C AST'
!


!CTypeNode methodsFor:'accessing'!

cByteSize

    ^self subclassResponsibility

    "Created: / 09-07-2008 / 19:26:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

ffiTypeSymbol
    ^ self subclassResponsibility

    "Created: / 03-07-2008 / 22:54:39 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

priority

    ^self isForeign 
        ifTrue:[super priority - 1]
        ifFalse:[super priority]

    "Created: / 09-07-2008 / 20:41:19 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

stxStructFieldGetterSelector
    ^ #at:

    "Created: / 09-09-2008 / 21:32:39 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

stxStructFieldSetterSelector
    ^ (self stxStructFieldGetterSelector , 'put:') asSymbol

    "Created: / 09-09-2008 / 21:33:21 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!CTypeNode methodsFor:'converting'!

resolved
    ^ self

    "Created: / 17-02-2008 / 17:56:03 / janfrog"
! !

!CTypeNode methodsFor:'queries'!

shouldBeIgnored

    ^super shouldBeIgnored or:
        [self isAnonymous]

    "Created: / 22-02-2009 / 15:02:40 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!CTypeNode methodsFor:'testing'!

isAnonymous

    ^cName isNil

    "Created: / 04-07-2008 / 11:44:38 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

isCCharNode
    ^ false

    "Created: / 04-07-2008 / 09:26:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

isCTypeNode
    ^ true

    "Created: / 17-02-2008 / 21:49:53 / janfrog"
!

isForeign

    ^cName isNil

    "Created: / 04-07-2008 / 11:44:45 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!CTypeNode class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/cvut-fel/cface/Cface__CTypeNode.st,v 1.1 2008/02/26 15:59:04 vranyj1 Exp $'
!

version_SVN
    ^ '$Id$'
! !
